import Vue from 'vue'

import Cookies from 'js-cookie'

import Element from 'element-ui'
import './assets/styles/element-variables.scss'

import '@/assets/styles/index.scss' // global css
import '@/assets/styles/yongtian.scss' // yongtian css
import App from './App'
import store from './store'
import router from './router'
import directive from './directive' //directive
import Print from '@/assets/js/print.js' // 引入附件的js文件
Vue.use(Print) // 注册
import './assets/icons' // icon
import './permission' // permission control
import { getDicts } from "@/api/system/dict/data";
import { getConfigKey } from "@/api/system/config";
import { parseTime, resetForm, addDateRange, selectDictLabel, selectDictLabels, download, downloadBlob, handleTree } from "@/utils/yongtian";
import Pagination from "@/components/Pagination";
// 自定义表格工具组件
import RightToolbar from "@/components/RightToolbar"
// 富文本组件
import Editor from "@/components/Editor"
// 文件上传组件
import FileUpload from "@/components/FileUpload"
// 图片上传组件
import ImageUpload from "@/components/ImageUpload"
// 字典标签组件
import DictTag from '@/components/DictTag'
// 头部标签组件
import VueMeta from 'vue-meta'
// echarts
import echarts from 'echarts'
import {set } from 'nprogress'
//公共变量
// import { BASEPATH } from "@/assets/js/common.js";
//创建自定义指令
Vue.directive('down', {
        inserted: (el, binding) => {
            el.style.cssText = 'cursor: pointer;color:#46a6ff;'
                // setTimeout(() => {
            el.addEventListener('click', () => {
                    let link = document.createElement('a')
                    let url = binding.value
                    console.log(link)
                        // 这里是将url转成blob地址，
                    fetch(url).then(res => res.blob()).then(blob => { // 将链接地址字符内容转变成blob地址
                        link.href = URL.createObjectURL(blob)
                        link.download = ''
                        document.body.appendChild(link)
                        link.click()
                    })
                })
                // }, 500)

        }
    })
    // 全局方法挂载
Vue.prototype.getDicts = getDicts
Vue.prototype.getConfigKey = getConfigKey
Vue.prototype.parseTime = parseTime
Vue.prototype.resetForm = resetForm
Vue.prototype.addDateRange = addDateRange
Vue.prototype.selectDictLabel = selectDictLabel
Vue.prototype.selectDictLabels = selectDictLabels
Vue.prototype.download = download
Vue.prototype.downloadBlob = downloadBlob
Vue.prototype.handleTree = handleTree
Vue.prototype.$echarts = echarts
    // Vue.prototype.BASEPATH = BASEPATH

Vue.prototype.msgSuccess = function(msg, time) {
    this.$message({ showClose: true, message: msg, type: "success", duration: time || 3000 });
}

Vue.prototype.msgError = function(msg) {
    this.$message({ showClose: true, message: msg, type: "error" });
}

Vue.prototype.msgInfo = function(msg) {
    this.$message.info(msg);
}

// 全局组件挂载
Vue.component('DictTag', DictTag)
Vue.component('Pagination', Pagination)
Vue.component('RightToolbar', RightToolbar)
Vue.component('Editor', Editor)
Vue.component('FileUpload', FileUpload)
Vue.component('ImageUpload', ImageUpload)

Vue.use(directive)
Vue.use(VueMeta)

/**
 * If you don't want to use mock-server
 * you want to use MockJs for mock api
 * you can execute: mockXHR()
 *
 * Currently MockJs will be used in the production environment,
 * please remove it before going online! ! !
 */

Vue.use(Element, {
    size: Cookies.get('size') || 'medium' // set element-ui default size
})

Vue.config.productionTip = false

new Vue({
    el: '#app',
    router,
    store,
    render: h => h(App)
})
